<?php

class IndexController extends pm_Controller_Action
{
    private $api;
    private $debug;
    private $path;
	
	public function init()
    {
        parent::init();
        
        // Init title for all actions
        $this->view->pageTitle = 'Dnsmeapi Module';

        // Init tabs for all actions
        $this->view->tabs = array(
            array(
                'title' => 'API settings',
                'action' => 'setting',
            ),
            array(
                'title' => 'Primary DNS',
                'action' => 'primary',
            ),
            array(
                'title' => 'Secondary DNS',
                'action' => 'second',
            ),
        );
         $this->api = $this->get_api_keys();
		 $this->debug="";
                 
                 $this->path="";
		
    }

    public function indexAction()
    {
        // Default action will be formAction
        // if user has api settings to primary dns
        // else setting api
        
       
        if(empty($this->api['key'])){
            $this->_forward('setting');
			
        }else{
            $this->_forward('primary');
        }
        
        
        

    }

    public function settingAction()
    {
        
//system('/usr/local/psa/admin/sbin/modules/dnsmeapi/DNSmeapiAdmin', $varout);
//echo $varout;
		$form = new pm_Form_Simple();
        // Display simple text in view
        $this->view->ptitle = 'Please input your API account info below:';
		if ($this->getRequest()->isPost() && $form->isValid($this->getRequest()->getPost())) {
            // Form proccessing here
			
			//$form->populate($_POST);
			$values = $this->getRequest()->getPost();
            $this->set_api_keys($values['key'], $values['secret'], $values['url'], $values['add']);
            $this->_status->addMessage('info', _('Settings was successfully saved.'));
            $this->_helper->json(array('redirect' => pm_Context::getBaseUrl()));
			//$this->api = $this->get_api_keys();
			
			
			
        }
        // Init form here
		$this->api['allkeys'] = pm_Settings::get('allkeys');
        $this->view->api = $this->api;
		
        $form->addElement('text', 'key', array(
            'label' => 'API key',
            'value' => $this->api['key'],
			'description' => 'DNS madeasy API key',
            'required' => true,
            'validators' => array(
                array('NotEmpty', true),
            ),
        ));
        $form->addElement('text', 'secret', array(
            'label' => 'API secret',
            'value' =>  $this->api['secret'],
            'description' => 'DNS madeasy API secret',
			'required' => true,
            'validators' => array(
                 array('NotEmpty', true),
            ),
        ));
        
        
        $form->addElement('select', 'url', array(
            'label' => 'API url',
            'multiOptions' => array('https://sandbox.dnsmadeeasy.com' => 'SandBox API', 'https://api.dnsmadeeasy.com/V2.0' => 'Live API'),
            'value' => $this->api['url'],
			'description' => 'If you want to test only, choose the Sandbox so that your domain is not affected',
            'required' => true,
        ));
       
       /*  $form->addElement('checkbox', 'add', array(
            'label' => 'Automatically add to secondary DNS when new domain is added.',
            'value' => $this->api['add'],
        )); */
        
        $form->addControlButtons(array(
            'cancelLink' => pm_Context::getModulesListUrl(),
        ));

        

        $this->view->form = $form;
    }

  
  
  function _init_primary()
    {
        // list primary domain
        // add domain
        // delete domain
        // add soa records
		// Display simple text in view
        $this->view->ptitle = 'Primary DNS';
		$path ="index.php/index/";
		$this->view->baseurl=pm_Context::getBaseUrl() . $path;
		$tab2 = array(
            
           
                array(
                'title' => 'Add Domain',
                'description' => 'Add new domain(s)',
                'class' => 'sb-app-info',
                'link' => $this->view->baseurl . 'primaryadd',
				'icon' => $this->view->skinUrl('/') . "img/icons/small/app-info_16.gif?11.0",
				),
           
                array(
                'title' => 'SOA records',
                'description' => 'Manage soa records',
                'class' => 'sb-app-info',
                'link' => $this->view->baseurl . 'primarysoa',
				'icon' => $this->view->skinUrl('/') . "img/icons/small/app-info_16.gif?11.0",
				),
           
        );
		$this->view->tabs2=$tab2;
		
                $values =$this->getRequest()->getParams();
               if(!empty($values['domain'])){
					$tab22 = array();
                   $xxx='id=' . $values['id'];
                   $xxx.='&domain=' . $values['domain'];
                   foreach(array('A','CNAME','ANAME','MX','HTTPRED','TXT','SPF','PTR','NS','AAAA','SRV') as $v):
                        $tab22[]=array(
                            'title' => $v,
                            'class' => 'sb-app-info',
                            'description' => 'Manage ' . $v . ' records',
                            'link' =>  $this->view->baseurl . 'arecord?' . $xxx . '&type=' . $v 
                        );
                   endforeach;
				   
                  $this->view->tabrecords=$tab22;
               }
               //$this->getRequest()->
//                if(!empty($values['type']) && substr($this->getRequest()->getActionName(),0,7) == 'arecord'):
//                    $this->view->ptitle.=": " . $values['type'] ." records";
//                endif;
               
			   
                $this->path="/dns/managed/";
	}
        function _init_second()
    {
        // list primary domain
        // add domain
        // delete domain
        // add soa records
		// Display simple text in view
        $this->view->ptitle = 'Secondary DNS';
        $path ="index.php/index/";
        
        $this->view->baseurl=pm_Context::getBaseUrl() . $path;
        $this->view->tabs2 = array(
            
           
                array(
                'title' => 'Add Secondary Domain',
                'description' => 'Add new secondary domain(s)',
                'class' => 'sb-app-info',
                'link' => $this->view->baseurl . 'secondadd',
            
				),
//             array(
//                'title' => 'Transfer ACL (AXFR)',
//                'description' => 'Transfer ACL (AXFR)',
//                'class' => 'sb-app-info',
//                'link' => $this->view->baseurl . 'aclrecord?type=transferAcl',
//				),
                array(
                'title' => 'Secondary IP Sets',
                'description' => 'Secondary IP Sets',
                'class' => 'sb-app-info',
                'link' => $this->view->baseurl . 'aclrecord?type=secondary%2FipSet',
				),
           
        );
                $this->path="/dns/secondary/";
	}
	public function primaryAction(){
		$this->_init_primary();
		
		
        $dnslist=$this->_do_request(array($this->path));
        $this->view->dnslist = $dnslist;
    }
    
    function _update_soa($values,$opts=array()){
	$commands=array();
	$path = $opts['path']?$opts['path']:'soa';
	$path = "/dns/$path/";
        $post=array();
	// copy $values to new array
        $stuffkeys = array('id' => 1,'name' => 1, 'email' => 1, 'comp' => 1, 'ttl' => 1, 'retry' => 1, 'serial' => 1, 'refresh' => 1, 'expire' => 1, 'negativeCache' => 1);
        foreach($values as $k => $v)
            if($stuffkeys[$k] != "")
               $post[$k] = $v;
        
	$action = strtoupper($opts['method']);
	if(!empty($values['id'])){
		### edit
		$path.=$values['id'];
		array_push($commands,$path);
		##push(@commands,"-X PUT");
                if($action=='')
                    $action='PUT' ;

	}else{
		### add

		array_push($commands,$path);
		#push(@commands,"-X POST");
                if($action=='')
                    $action='POST';

	}
	array_push($commands,"-X $action");

	//array_push($commands, '-H accept:' . $format);
	//array_push($commands,"-H content-type:$outformat");

	//### process ips
	if(!empty( $values['ips'])){

		$values['ips']=~ preg_replace('/\r/',"",$values['ips']);
		$values['ips']=~ preg_replace('/\n/',"",$values['ips']);
		$post['ips']=preg_split('/,/',$values['ips']);
                
                //echo print_r($values,true);
	}
        
            

	unset($post['type']);

	$json = json_encode($post);
        
	array_push($commands,"-d '$json'");
	//#print join("<br>",@commands);##return;
        //$this->debug='debug';
        
	return $this->_do_request($commands);
        
    }
	function _update_domain($values,$opts = array()){
		// addDomain need what?
            if(in_array('path',$opts))
                    $this->path = "/dns/" . $opts['path'] . "/";
                    
            //prepare path, commands,
            $post=array();
  	//$domains=array();
        $commands = array();
        $method="-X PUT";
	if(!empty($values['id']) && $values['id'] > 0){
		### edit
		$this->path.=$values['id'];
		//array_push($commands,$this->path);
		

	}else{
		//### add
                $domains = preg_split ('/\n/', $values['domain']);
                $domains = preg_split ('/\r/', $values['domain']);
                
		$post['names'] = $domains;
		
                $method="-X POST";

	}
        array_push($commands,$this->path);
        array_push($commands,$method);
        $stuffkeys =array('templateId' => 1,'vanityId'  => 1,'soaId' => 1,'transferAclId' => 1,'folderId' => 1,'ipSetId' => 1);
       // echo print_r($values,true);
       // return;
	foreach ($values as $k => $v){
                //echo "$k =" . $values[$k] . "<br>";
                //if(in_array("$k",$stuffkeys) && !empty($values["$k"]))
                if($stuffkeys[$k] != "")
                    $post["$k"] = $v ;
	}
	if(!empty($values['gtdEnabled']))
                $post['gtdEnabled']='true';

	//array_push($commands, '-H accept:' . $format);
	//array_push($commands,"-H content-type:$outformat");
	$json = json_encode($post) ;
	array_push($commands,"-d '$json'");
            
            // call api
        $this->debug= $opts['debug'];
        return $this->_do_request($commands);
            
		
	}
        public function primarydelAction(){
               $this->_init_primary();
		//$path="/dns/managed/";
		
		$values =$this->getRequest()->getParams(); 
                if(!empty($values['id'])){
                    $this->_delete_Domain(array(id => $values['id']));
                    $this->_status->addMessage('info', _('Domain was successfully deleted.'));

                }
                //$this->_helper->json(array('redirect' => pm_Context::getBaseUrl()));
                $this->_forward('primary');
                
        }
        
	public function primaryaddAction(){
		$this->_init_primary();
		//$path="/dns/managed/";
		
		$values =$this->getRequest()->getParams();
	//	$this->view->get_params= print_r($values,true);
        $form = new pm_Form_Simple();
        // Display simple text in view
//        $this->view->ptitle = 'Please input your API account info below:';
		if ($this->getRequest()->isPost() && $form->isValid($this->getRequest()->getPost())) {
            // Form proccessing here
			
			//$form->populate($_POST);
			$values = $this->getRequest()->getPost();
			// add or update domain here
			
            $rs = $this->_update_domain($values, array('debug' => ''));
            $this->debug="";
            //echo print_r($rs,true);
            if(empty($rs['error'])):
                $this->_status->addMessage('info', _('Domain(s) were successfully saved.'));
                $this->_helper->json(array('redirect' => pm_Context::getBaseUrl()));
            endif;
            echo implode ("<br>",$rs['error']);
           // $this->_status->addMessage('info', $rs['error']);
			//$this->api = $this->get_api_keys();
			
			
			
        }
        // Init form here
        $rec=array();
	if(empty($values['id'])):
            $form->addElement('textarea', 'domain', array(
            'label' => 'Domain(s)',
            'value' => $values['domain'],
			'description' => 'Your domain(s)',
            'required' => true,
			 'rows' => 4,
            'validators' => array(
                array('NotEmpty', true),
            ),
        ));
        else:
            $form->addElement('hidden', 'id', array(
            'label' => 'API secret',
            'value' =>  $values['id'],
			
        ));
        $rec = $this->_getDomainStuff(array('id' => $values['id']));
        $form->addElement('simpleText', 'currentDomain', array(
            'label' => 'Domain: ' . $rec['name'] . "",
            'escape' => false,
            'value' =>  '',));
        
        
        //echo print_r($rec);
        endif;	
        
                $form->addElement('simpleText', 'AdvanceSettings', array(
            'label' => 'Advance Settings',
            'value' =>  '',
			
        ));
                
        // global
           $form->addElement('checkbox', 'gtdEnabled', array(
            'label' => 'Global Traffic Director',
            'value' =>  $rec['gtdEnabled'],
               
			
        ));     
                
        // template
           $folderRecs = $this->_get_Form_dnsRecord(array('path' => 'template'));
           
                
        $form->addElement('select','templateId',array(
            'label' => 'Applied Template',
            'value' => $rec['templateId'],
            'multiOptions'  => $folderRecs,
            
            
        )
                );
        
       // vanility
        $folderRecs = $this->_get_Form_dnsRecord(array('path' => 'vanity'));
           
                
        $form->addElement('select','vanityId',array(
            'label' => 'Vanity NS Config',
            'value' => $values['vanityId'],
            'multiOptions'  => $folderRecs,
            
            
        )
                );
       //
               $folderRecs = $this->_get_Form_dnsRecord(array('path' => 'soa'));
           
                
        $form->addElement('select','soaId',array(
            'label' => 'Custom SOA Record',
            'value' => $rec['soaId'],
            'multiOptions'  => $folderRecs,
            
            
        )
                );    
// alc xfer
                
            $folderRecs = $this->_get_Form_dnsRecord(array('path' => 'transferAcl'));
           
                
        $form->addElement('select','transferAclId',array(
            'label' => 'Zone Transfer (AXFR ACL)',
            'value' => $rec['transferAclId'],
            'multiOptions'  => $folderRecs,
            
            
        )
                );    
//folder                
        
        $folderRecs = array();
        $folders = $this->_getDomainStuff(array('path' => 'folder'));
        //if(in_array('data',$folders))
                foreach($folders as $folder){
                    $folderRecs[$folder['value']] = $folder['label'];
                }

        
                
        $form->addElement('select','folderId',array(
            'label' => 'Folder',
            'value' => $rec['folderId'],
            'multiOptions'  => $folderRecs,
            'required'  => true,
            
        )
                );
        
        
        
        
       
        
        $form->addControlButtons(array(
            'cancelLink' => pm_Context::getBaseUrl() . 'index.php/index/primary/',
        ));

        

        $this->view->form = $form;
        
    }
    function _get_Form_dnsRecord($opts=array()){
               $folders = $this->_getDomainStuff($opts);
//                              if($opts['path'] =='vanity')
//                   echo print_r($folders,true);
               $folderRecs = array();
               if(!empty($folders['data']))
                       $folders  = $folders['data'];
               if($opts['path'] != 'folder')
                    array_push($folderRecs, 'None');        
               foreach($folders as $folder){
                   if(!empty($folder['lable']))
                    $folderRecs[$folder['value']] = $folder['label'];
                   else
                       $folderRecs[$folder['id']] = $folder['name'];
                }
                
                
                return $folderRecs;
           }
    public function primarysoaAction(){
	$this->_init_primary();
	//$path="/dns/managed/";
		
        $values =$this->getRequest()->getParams();
                
        $soarecs = $this->_getDomainStuff(array('path' => 'soa'));
        //echo print_r($soarecs);
        $this->view->soarecs=$soarecs;        
    }
    public function primarysoadelAction(){
            $this->_init_primary();
            //$path="/dns/managed/";

            $values =$this->getRequest()->getParams();

             $this->_update_soa($values,array('path' => 'soa', 'method'=> 'delete'));
             $this->_status->addMessage('info', _('SOA record was successfully deleted.'));
            //$this->_helper->json(array('redirect' => $this->view->baseurl . "primarysoa"));
             $this->_forward('primarysoa');

    }
    public function primarysoaaddAction(){
		$this->_init_primary();
		//$path="/dns/managed/";
		
		$values =$this->getRequest()->getParams();
	//	$this->view->get_params= print_r($values,true);
        $soarec = array();
        if(!empty($values['id']))
            $soarec = $this->_getDomainStuff (array('path' => 'soa', 'id' => $values['id']));
       
        $form = new pm_Form_Simple();
        // Display simple text in view
        //$this->view->ptitle = 'Please input your API account info below:';
		if ($this->getRequest()->isPost() && $form->isValid($this->getRequest()->getPost())) {
            // Form proccessing here
			
			//$form->populate($_POST);
			$values = $this->getRequest()->getPost();
			// add or update domain here
	    //echo print_r($values,true);
            
            $this->_update_soa($values,array('path' => 'soa'));
            
            $this->_status->addMessage('info', _('SOA record were successfully saved.'));
            $this->_helper->json(array('redirect' => $this->view->baseurl . "primarysoa"));
			//$this->api = $this->get_api_keys();
			
			
			
        }
        // Init form here
		
        $form->addElement('text', 'name', array(
            'label' => 'Name',
            'value' => $soarec['name'],
			
            'required' => true,
			 
            'validators' => array(
                array('NotEmpty', true),
                array('StringLength', true, array(3, 255)),
            ),
        ));
        
        
        $form->addElement('hidden', 'id', array(
            'label' => 'API secret',
            'value' =>  $soarec['id'],
			
        ));
        
        $form->addElement('text', 'email', array(
            'label' => 'Email',
            'value' => $soarec['email'],
			
            'required' => true,
			 
            'validators' => array(
                array('NotEmpty', true),
                array('EmailAddress'),
                
            ),
        ));
        $form->addElement('text', 'comp', array(
            'label' => 'Computer name',
            'value' => $soarec['comp'],
			
            'required' => true,
			 
            'validators' => array(
                array('NotEmpty', true),
                array('StringLength', true, array(3, 255)),
            ),
        ));
        $form->addElement('text', 'ttl', array(
            'label' => 'TTL',
            'value' => $soarec['ttl'],
			
            'required' => true,
			 
            'validators' => array(
                array('NotEmpty', true),
                array('StringLength', true, array(1, 10)),
            ),
        ));
        $form->addElement('text', 'serial', array(
            'label' => 'Starting Serial',
            'value' => $soarec['serial'],
			
            'required' => true,
			 
            'validators' => array(
                array('NotEmpty', true),
                array('StringLength', true, array(1, 10)),
            ),
        ));
        $form->addElement('text', 'refresh', array(
            'label' => 'Refresh',
            'value' => $soarec['refresh'],
			
            'required' => true,
			 
            'validators' => array(
                array('NotEmpty', true),
                array('StringLength', true, array(1, 10)),
            ),
        ));
       $form->addElement('text', 'retry', array(
            'label' => 'Retry',
            'value' => $soarec['retry'],
			
            'required' => true,
			 
            'validators' => array(
                array('NotEmpty', true),
                array('StringLength', true, array(1, 10)),
            ),
        ));
       $form->addElement('text', 'expire', array(
            'label' => 'Expire',
            'value' => $soarec['expire'],
			
            'required' => true,
			 
            'validators' => array(
                array('NotEmpty', true),
                array('StringLength', true, array(1, 10)),
            ),
        ));
       $form->addElement('text', 'negativeCache', array(
            'label' => 'Negative Cache',
            'value' => $soarec['negativeCache'],
			
            'required' => true,
			 
            'validators' => array(
                array('NotEmpty', true),
                array('StringLength', true, array(1, 10)),
            ),
        ));
        
        $form->addControlButtons(array(
            'cancelLink' => pm_Context::getBaseUrl() . 'index.php/index/primarysoa/',
        ));

        

        $this->view->form = $form;
        
    }
	function _do_request($commands=array(),$opts=array()){
		//$this->_sign();
		// create path(full url)
		
		$curl='/usr/bin/curl';
		### if the ssl does not work, use the below options
		$curl='/usr/bin/curl -k';
		$format = 'application/xml';
		$format = 'application/json';
		$outformat='application/json';
		
		//$requestDate = date("D M j Y H:i:s P", time());
		$requestDate = date("r", time());
		
		//$hmac= hmac_sha1_hex($requestDate, $keys->{secretKey});
		//$hmac = $this->_hmac_sha1($requestDate,$this->api['secret']);
		//$auth_method='sha1';
		//b3502e6116a324f3cf4a8ed693d78bcee8d8fe3c
		//a5499400b35f6c21fab4c8876b64c3b5e7fe542f
		//YzY4N2UyNjNmZWFjMGMwM2JmNThhMTI0NTUzY2IzNWYyNWI3OGI3Mw==
		$auth_method="sha1";
		//$hmac = hash_hmac("$auth_method", $requestDate, $this->api['secret'], FALSE);
		$hmac=$this->_hmac_sha1($this->api['secret'],$requestDate,$auth_method);
		
		$apiKeyHeader = "x-dnsme-apiKey:" . $this->api['key'];
		$hmacHeader = "x-dnsme-hmac:" . $hmac;
		$requestDateHeader = "x-dnsme-requestDate:" . $requestDate;

	/*### include api url??
	##$comands[0]='"' . $keys->{apiURL}  . $comands[0] . '"';
	### del all domains must use the live api url
	
	if(in_array('cmdx',$opts,true) && $opts['cmdx'] == 'delAll'){
		##$comands[0]=~ s/sandbox\.//;
		##https://api.dnsmadeeasy.com/V2.0
		$comands[0]='"' . $this->api['url'] . $comands[0] . '"';
	}else{
		$comands[0]='"' . $keys->{apiURL}  . $comands[0] . '"';
	}**/
	//$this->view->js=print_r($commands,true);
	$url='"' . $this->api['url'] . array_shift($commands) . '"';
	
	#push(@comands,'-I -w "%{http_code}"');
	if ($this->debug == 'returned_status') 
		array_push($commands,'-i');
	/*
	$url ='';## shift @comands;
#	# run curl with the DNS Made Easy API headers
*/
	array_push($commands, '-H accept:' . $format);
	array_push($commands,"-H content-type:$outformat");
	$cmd = $curl . " $url " . implode(" ", $commands). " -H \"$apiKeyHeader\" -H \"$hmacHeader\" -H \"$requestDateHeader\"";
	$this->view->cmd=$cmd;
	$this->view->js=$js;
	$this->view->js.="secret:" . $this->api['secret'];
	if ($this->debug == "debug")
			echo "\ncmd:$cmd:";
		
	 //passthru ($cmd,$rs);
	 $retcode="";
         if ($this->debug == "9")
             $rs=system($cmd,$retcode);
         else
            exec($cmd,$rs,$retcode);
	//$this->view->cmd.=$retstatus;
	$rs = implode("",$rs);
	return json_decode($rs,true);
		// Request method
		
	}
	
	function _hmac_sha1($key, $data,$hashmethod)
{
	//$cmd = "/var/www/vhosts/g2.cgito.net/httpdocs/cgi-bin/hmac_date.pl '$data' '$key'";
	// $rs="";
	 //passthru ($cmd,$rs);
	 //	 return $rs;
	// return system($cmd);
	return hash_hmac("$hashmethod", $data, $key);
	return base64_encode(hash_hmac("$hashmethod", $data, $key, true));
	return hash_hmac ("sha1",$data,$key);
	
	$my_sign = hash_hmac("sha1", $data, base64_decode(strtr($key, '-_', '+/')), true);
	$my_sign = strtr(base64_encode($my_sign), '+/', '-_');
	return $my_sign;
    // Adjust key to exactly 64 bytes
    if (strlen($key) > 64) {
        $key = str_pad(sha1($key, true), 64, chr(0));
    }
    if (strlen($key) < 64) {
        $key = str_pad($key, 64, chr(0));
    }

    // Outter and Inner pad
    $opad = str_repeat(chr(0x5C), 64);
    $ipad = str_repeat(chr(0x36), 64);

    // Xor key with opad & ipad
    for ($i = 0; $i < strlen($key); $i++) {
        $opad[$i] = $opad[$i] ^ $key[$i];
        $ipad[$i] = $ipad[$i] ^ $key[$i];
    }

    return sha1($opad.sha1($ipad.$data, true));
}
	
    public function secondAction()
    {
        
        $this->_init_second();
        
        $this->view->dnslist = $this->_getDomainStuff(array('path' =>'secondary'));
        $this->view->folders = $this->_getDomainStuff(array('path' => 'folder'));
        $this->view->ips = $this->_getDomainStuff(array('path' => 'secondary/ipSet'));
        
    }

    public function seconddelAction()
    {
        
        $this->_init_second();
        $values =$this->getRequest()->getParams(); 
                if(!empty($values['id'])){
                    $this->_delete_Domain(array(id => $values['id'], 'path' => 'secondary'));
                    $this->_status->addMessage('info', _('Domain was successfully deleted.'));

                }
                //$this->_helper->json(array('redirect' => pm_Context::getBaseUrl()));
                $this->_forward('second');
        
    }
    function _update_named($opts=array()){
        $cmd="/usr/local/psa/admin/sbin/modules/dnsmeapi/DNSmeapiAdmin " . $opts['domain'];
        $other = system($cmd,$mysql_admin);
//        echo "$mysql_admin : $cmd";
//        // edit
//        $domain=$opts['domain'];
        //copy back
//        $other = system("$wrapper copy_file $dest $src",$mysql_admin,$retcode);
        
    }

    public function secondaddAction()
    {
        
        $this->_init_second();
        $values =$this->getRequest()->getParams();
	//	$this->view->get_params= print_r($values,true);
        $form = new pm_Form_Simple();
        $base_index_url = $this->view->baseurl . "second/";
        // Display simple text in view
        $this->view->ptitle = 'Please input your API account info below:';
		if ($this->getRequest()->isPost() && $form->isValid($this->getRequest()->getPost())) {
            // Form proccessing here
			
			//$form->populate($_POST);
			$values = $this->getRequest()->getPost();
			// add or update domain here
          
//	echo '/etc/named.conf content:' . system('cat /etc/psa/.psa.shadow');
//        echo '/etc/named.conf content:' . system('cat /etc/named.conf');
//                        $mysql_admin="";
//         $other = system('/usr/local/psa/admin/sbin/wrapper server_dns -u -add-acl 192.0.2.79',$mysql_admin,$retcode);
//         echo "mysql pw:". $mysql_admin . ': error:' . $other;
                        
                        
                        
            $rs = $this->_update_domain($values, array('path' => 'secondary'));
//            var_dump($rs);
            if(empty($rs['error'])){
                $this->_update_named($values);
                $this->_status->addMessage('info', _('Domain(s) were successfully saved.'));
                $this->_helper->json(array('redirect' => $base_index_url));
            }else{
            
            echo $rs['error'][0];
            }
			//$this->api = $this->get_api_keys();
			
			
			
        }
        // Init form here
		
        $form->addElement('textarea', 'domain', array(
            'label' => 'Domain(s)',
            'value' => $values['domain'],
			'description' => 'Your domain(s)',
            'required' => true,
			 'rows' => 4,
            'validators' => array(
                array('NotEmpty', true),
            ),
        ));
        $folderRecs = array();
        $folders = $this->_getDomainStuff(array('path' => 'folder'));
        //if(in_array('data',$folders))
                foreach($folders as $folder){
                    $folderRecs[$folder['value']] = $folder['label'];
                }
                
        $form->addElement('select','folderId',array(
            'label' => 'Folder',
            'value' => $values['folderId'],
            'multiOptions'  => $folderRecs,
            'required'  => true,
            
        )
                );
        //ipSetId
        $ipsRecs = array();
        $ips = $this->_getDomainStuff(array('path' => 'secondary/ipSet'));
        //if(in_array('data',$folders))
                foreach($ips['data'] as $ip){
                    $ipsRecs[$ip['id']] = $ip['name'];
                }
                
        $form->addElement('select','ipSetId',array(
            'label' => 'IPset',
            'value' => $values['ipSetId'],
            'multiOptions'  => $ipsRecs,
            'required'  => true,
            
        )
                );
        
        $form->addElement('hidden', 'id', array(
            'label' => 'API secret',
            'value' =>  $values['id'],
			
        ));
        
        
       
        
        

        
 $form->addControlButtons(array(
            'cancelLink' => $base_index_url,
        ));
        $this->view->form = $form;
        
        
    }
    public function arecordaddAction(){
         $this->_init_primary();
         
        $values =$this->getRequest()->getParams();
        $base_index_url = $this->view->baseurl . "arecord/?type=". $values['type'] . "&id=" . $values['id'] . "&domain=". $values['domain'];
        $form = new pm_Form_Simple();
        // Display simple text in view
//        $this->view->ptitle = 'Please input your API account info below:';
		if ($this->getRequest()->isPost() && $form->isValid($this->getRequest()->getPost())) {
            // Form proccessing here
			
			//$form->populate($_POST);
			$values = $this->getRequest()->getPost();
			// add or update domain here
//			$this->debug="debug";
            $rs = $this->_update_arecord($values, array('debug' => ''));
            $this->debug="";
            //echo print_r($rs,true);
            if(empty($rs['error'])):
                $this->_status->addMessage('info', _('Record was successfully saved.'));
                $this->_helper->json(array('redirect' => $base_index_url));
            endif;
            echo implode ("<br>",$rs['error']);
           // $this->_status->addMessage('info', $rs['error']);
			//$this->api = $this->get_api_keys();
			
			
			
        }
        // Init form here
       
        foreach(array('id','sourceId','domain','dnsrecords', 'typeid','type') as $v):
            $form->addElement('hidden', $v, array(
            'label' => 'API secret',
            'value' =>  $values[$v],
			
        ));
        endforeach;
        
        $this->_add_arecordForm($form,$values);
        
        
        
         $form->addControlButtons(array(
            'cancelLink' => $base_index_url,
        ));
        
        $this->view->form=$form;
        
    }
    function _add_arecordForm(&$form, $values=array()){
            $name_title="FQDN or IP";
            
            if($values['type'] == "ANAME" ):
    $name_title= 'FQDN or IP';
elseif($values['type'] == "CNAME" ):
    $name_title= 'Alias to';
elseif($values['type'] == "HTTPRED" ):
    $name_title= 'URL';
elseif($values['type'] == "PTR" ):
    $name_title= 'System';
elseif($values['type'] == "AAAA" ):
    $name_title= 'IPV6';
else:
    $name_title= 'Value';


endif;

$form->addElement('simpleText', 'arecordSimpleText', array(
            'label' => $values['type'] . ' RECORD',
            'escape' => false,
            'value' => '<a href="#"></a>',
        ));
            
$form->addElement('text', 'typename', array(
            'label' => 'Name',
            'value' => $values['typename'],
			
            'required' => true,
			 
            'validators' => array(
                array('NotEmpty', true),
            ),
        ));	
            switch($values['type']){
                case "A":
                    
	$form->addElement('text', 'value', array(
            'label' => 'IP',
            'value' => $values['value'],
			
            'required' => true,
			 
            'validators' => array(
                array('NotEmpty', true),
            ),
        ));	
        $form->addElement('checkbox', 'dynamicDns', array(
            'label' => 'dynamicDns',
            'value' => $values['dynamicDns'],
			
            'required' => false,
			 
           
        ));
        
        
         break;
        case "MX":    
            $form->addElement('text', 'value', array(
            'label' => 'Server',
            'value' => $values['value'],
			
            'required' => true,
			 
            'validators' => array(
                array('NotEmpty', true),
            ),
        ));	
         $form->addElement('text', 'mxLevel', array(
            'label' => 'MX Level',
            'value' => $values['mxLevel'],
			
            'required' => true,
			 
            'validators' => array(
                array('NotEmpty', true),
            ),
        ));
            
             break;
        case "SRV":   
            $form->addElement('text', 'priority', array(
            'label' => 'priority',
            'value' => $values['priority'],
			
            'required' => true,
			 
            'validators' => array(
                array('NotEmpty', true),
            ),
        ));
            $form->addElement('text', 'priority', array(
            'label' => 'priority',
            'value' => $values['priority'],
			
            'required' => true,
			 
            'validators' => array(
                array('NotEmpty', true),
            ),
        ));
            
            break;
			
                default:
        
            
	$form->addElement('text', 'value', array(
            'label' => $name_title,
            'value' => $values['value'],
			
            'required' => true,
			 
            'validators' => array(
                array('NotEmpty', true),
            ),
        ));	
        
         
        break;
         
            }// end switch
			
		if($values['type'] == "HTTPRED" ){
				$form->addElement('select','redirectType',array(
            'label' => 'Redirect Type',
            'value' => $values['redirectType'],
            'multiOptions'  => array('Hidden Frame Masked' => 'Hidden Frame Masked', 'Standard - 301' => 'Standard - 301', 'Standard - 302' => 'Standard - 302'),
            'required'  => true,
            
        ));
		$form->addElement('text', 'title', array(
            'label' => 'Title',
            'value' => $values['title'],
			
            'required' => false,
			 
            
        ));
		$form->addElement('text', 'keywords', array(
            'label' => 'Keywords',
            'value' => $values['keywords'],
			
            'required' => false,
			 
            
        ));
		$form->addElement('textarea', 'description', array(
            'label' => 'Description',
			'rows' => 3,
            'value' => $values['description'],
			
            'required' => false,
			 
            
        ));
		
		
		}
           
        $form->addElement('text', 'ttl', array(
            'label' => 'TTL',
            'value' => $values['ttl'],
			
            'required' => true,
			 
            'validators' => array(
                array('NotEmpty', true),
            ),
        ));
        
        }
    public function arecorddelAction(){
       $values =$this->getRequest()->getParams();
       // $this->_init_primary();
//        $base_index_url = $this->view->baseurl . "arecord/?type=". $values['type'] . "&id=" . $values['id'] . "&domain=". $values['domain'];

       
//		 $this->debug="debug";	
       $rs = $this->_update_arecord($values, array('debug' => '', method => 'DELETE'));
        $this->debug="";
//        return;
            //echo print_r($rs,true);
       if(empty($rs['error'])):
        $this->_status->addMessage('info', _('Record was successfully deleted.'));
                //$this->_helper->json(array('redirect' => pm_Context::getBaseUrl()));
//                $this->_helper->json(array('redirect' => $base_index_url));
        else:
        echo implode ("<br>",$rs['error']);
        endif;
        $this->_forward('arecord');
    }
    public function arecordAction(){
         $this->_init_primary();
//         $base_index_url = $this->view->baseurl . "arecord/";
        $values =$this->getRequest()->getParams();
//        $this->debug='debug';
        $recs =$this->_domainRecords($values);//$array('path' => $values['type'], 'id' => $values['id']));
        $this->view->vals=$values;
//        echo print_r($recs,true);
        $this->view->recs = $recs;
        
    }
    function _domainRecords($opts=array()){

	
	$id = "";
        if(!empty($opts['id'])){
            $id = $opts['id'];
            unset ($opts['id']);
        }
        
	if(empty($id)){
		
		return array('error' => 'domain id must provider');


	}
/*
	###https://cp.v2.sandbox.dnsmadeeasy.com/dns/managed/861958/records?type=A&_search=false&nd=1374070995935&rows=10&page=1&sidx=name&sord=asc&_=1374070995936
#	unless($id){
#		_error("Three is no domain listed yet.");
#		return {};
#	}
	## if domain, query its??
*/
  	$t = time();
 
	$t2 = $t+1;
	$path = "/dns/managed/$id/records";
	if(!empty($opts['typeid'])){
		##$path.="/$opts{typeid}";
	}
	$path.="?type=" . $opts['type'] . "&_search=true&nd=$t&rows=10&page=1&sidx=name&sord=asc&_=$t2";

	$commands=array();
	array_push($commands,$path);

	return $this->_do_request($commands);



}
    public function aclrecordAction(){
         $this->_init_second();
         $base_index_url = $this->view->baseurl . "second/";
        $values =$this->getRequest()->getParams();
        $recs =$this->_getDomainStuff(array('path' => $values['type']));
        $this->view->vals=$values;
        //echo print_r($recs,true);
        $this->view->recs = $recs;
        
    }
    public function aclrecorddelAction(){
         $this->_init_second();
        
        $values =$this->getRequest()->getParams();
//         $base_index_url = $this->view->baseurl . "aclrecord/?type=" . $values['type'];
        $this->_getDomainStuff($values, array('path' => $values['type'], 'method' => 'delete', 'id' => $values['id']));
        $this->_forward('aclrecord');
    }
    public function aclrecordaddAction(){
         $this->_init_second();
         
        $values =$this->getRequest()->getParams();
        $base_index_url = $this->view->baseurl . "aclrecord/";
        $base_index_url = $this->view->baseurl . "aclrecord/?type=" . $values['type'];
	//	$this->view->get_params= print_r($values,true);
        $rec =$this->_getDomainStuff(array('path' => $values['type'], 'id' => $values['id']));
        $form = new pm_Form_Simple();
        
        // Display simple text in view
       // $this->view->ptitle = 'Please input your API account info below:';
		if ($this->getRequest()->isPost() && $form->isValid($this->getRequest()->getPost())) {
            // Form proccessing here
			
			//$form->populate($_POST);
			$values = $this->getRequest()->getPost();
			// add or update domain here
			//echo print_r($values,true);return;
            $this->_update_soa($values, array('path' => $values['type'], 'id' => $values['id']));
            $this->_status->addMessage('info', _('Record(s) were successfully saved.'));
            $this->_helper->json(array('redirect' => $base_index_url));
			//$this->api = $this->get_api_keys();
			
		//return;	
			
        }
        //echo print_r($rec);
        
        // Init form here
	$form->addElement('text', 'name', array(
            'label' => 'Name',
            'value' => $rec['name'],
			
            'required' => true,
			 
            'validators' => array(
                array('NotEmpty', true),
            ),
        ));	
        $form->addElement('textarea', 'ips', array(
            'label' => 'IPs',
            'value' => implode(",",$rec['ips']),
			
            'required' => true,
			 'rows' => 4,
            'validators' => array(
                array('NotEmpty', true),
            ),
        ));
        
        
        $form->addElement('hidden', 'id', array(
            'label' => 'API secret',
            'value' =>  $rec['id'],
			
        ));
        $form->addElement('hidden', 'type', array(
            'label' => 'API secret',
            'value' =>  $values['type'],
			
        ));
        
       
        
        $form->addControlButtons(array(
            'cancelLink' => $base_index_url,
        ));

        

        $this->view->form = $form;
        
    }

    
    static public function get_api_keys(){
        $key = self::get_user_key();
        $key = $key . "_dnsmeapi";
		 $api = array();
		// $api = (array)pm_Settings::get("$key");
		 //return $api;
		 
        $thekey = $key . '_key';
        $api['key'] = pm_Settings::get("$thekey");
        $thekey = $key . '_secret';
        $api['secret'] = pm_Settings::get("$thekey");
        
        $thekey = $key . '_url';
        $api['url'] = pm_Settings::get("$thekey");
		$thekey = $key . '_add';
        $api['add'] = pm_Settings::get("$thekey");
        //echo print_r($api);
        return $api;
    }
    public function set_api_keys($skey,$secret,$url,$add){
		//echo print_r($api);exit;
        $key = self::get_user_key();
        $key = $key . "_dnsmeapi";
        $thekey = $key . '_key';
        pm_Settings::set("$thekey","$skey");
		$this->api['key'] =$skey;
        $thekey = $key . '_secret';
        pm_Settings::set("$thekey","$secret");
		$this->api['secret'] =$secret;
        $thekey = $key . '_url';
        pm_Settings::set("$thekey","$url");
		$this->api['url'] =$url;
        $thekey = $key . '_add';
        pm_Settings::set("$thekey","$add");
		$this->api['add'] =$add;
		pm_Settings::set('allkeys',"$add~~$url~~$secret~~$key");
		//pm_Settings::set("$key",$this->api);
		//return $api;
        
    }

    public function get_user_key() {
        $client = pm_Session::getClient();
        $k = $client->getId();
        return $k;
    }

    function _getDomainStuff($opts=array()) {
        
        $commands=array();
	$stuff = $opts['path'];
	if($stuff == 'ipSet'){

		$stuff="secondary/$stuff";
	}
        $path=$this->path;
	$this->path='/dns/' . $stuff;

	if($stuff == 'folder'){
		$this->path='/security/folder';
	}
	if(!empty($opts['id'])){
            if(empty($opts['path'])):
                $this->path = $path . $opts['id'] ;
            else:
                if(!preg_match('/\/$/', $this->path))
		$this->path .= "/";
                $this->path .= $opts['id'] ;
                $this->path .= "/";
            
            endif;
            

	}
        /*
#	unless($path=~ /ipSet/){
#		$path.="/";
#	}
         * 
         */
	array_push($commands,$this->path);
	//#print join " ", @commands;
         //$this->debug='debug';
//        if(empty($opts['path']) && $opts['id']>0)
//            $this->debug='debug';
	return  $this->_do_request($commands);
	
    }

    function _delete_Domain($opts=array()) {
         if(!empty($opts['path'])){
             $this->path="/dns/" . $opts['path'] . "/";
             
         } 
         if(!empty($opts['id'])){
             $this->path.= $opts['id'];
         }
         $commands=array();
         array_push($commands,$this->path);
         array_push($commands,"-X DELETE");
         //$this->debug='debug';
         return $this->_do_request($commands);
    }

    function _update_arecord($in=array(), $opts=array()) {
        
	$commands=array();

	
	$path = "/dns/managed/" . $in['id'] . "/records";
        

	if(!empty($in['sourceId'])){
               
               
//		$path = "/dns/managed/" . $in['sourceId'] . "/records";
//		if($in['sourceId'] < 100000){
//			$path = "/dns/template/" . $in['sourceId'] ."/records";
//		}
               
	}
	//###_debug(\%Cpanel::FORM);return;
	$post=array(name => $in['typename'], id => $in['typeid'], type => $in['type']);
        $method="";
	if(!empty($in['typeid']) && $in['typeid'] !=''){
            /*
		### edit

		##dns/template/10956/records/9963100
		##$path.=$in{id};
		###$path = "/dns/template/$in['sourceId']/records/$in['typeid']";
             * 
             */
		$path.= "/" . $in['typeid'];

		
                $method='PUT';
		//array_push($commands,"-X PUT");
                

	}else{
		### add

		//push(@commands,$path);
                 $method='POST';
		//push(@commands,"-X POST");

	}
        array_push($commands,$path);
        if(!empty($opts['method']))
           $method = $opts['method'];
        array_push($commands,"-X " . $method);
        
        
	foreach(array('value', 'ttl') as $v){
		$post[$v]=$in[$v];
	}
	### some optionnal field based on each xx records
	### for A
        if(!empty($in['dynamicDns'])){
	//if(exists $in{dynamicDns}){
                $post['dynamicDns']='true';
		//$post{dynamicDns}= 'true';
	}
	## for mx mxLevel
	if(!empty($in['mxLevel'])){
		//$post{mxLevel}= $in{mxLevel};
            $post['mxLevel']=$in['mxLevel'];
	}
	### addtional fiedls
	foreach(array('mxLevel', 'priority', 'weight', 'port', 'title', 'keywords', 'description','redirectType') as $v){
		//$post{$_}=$in{$_} if exists $in{$_};
                if(!empty($in[$v]))
                    $post[$v]=$in[$v];
	}



	
	$json =  json_encode($post);
	array_push($commands,"-d '$json'");
	#print join("<br>",@commands);##return;
	return $this-> _do_request($commands);
    }
    
}
